// DXSpotterClientDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DXSpotterClient.h"
#include "DXSpotterClientDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDXSpotterClientDlg dialog

CDXSpotterClientDlg::CDXSpotterClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDXSpotterClientDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDXSpotterClientDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDXSpotterClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDXSpotterClientDlg)
	DDX_Control(pDX, IDC_RICHEDIT_INFO, m_reInfo);
	DDX_Control(pDX, IDC_LIST_DXS, m_lstSpotters);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDXSpotterClientDlg, CDialog)
	//{{AFX_MSG_MAP(CDXSpotterClientDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_REFRESH, OnButtonRefresh)
	ON_BN_CLICKED(IDC_BUTTON_CLOSE, OnButtonClose)
	ON_WM_COPYDATA()
	ON_BN_CLICKED(IDC_BUTTON_CONNECT, OnButtonConnect)
	ON_BN_CLICKED(IDC_BUTTON_DISCONNECT, OnButtonDisconnect)
	ON_BN_CLICKED(IDC_BUTTON_GETTEXT, OnButtonGetAllText)
	ON_BN_CLICKED(IDC_BUTTON_GETSPOTS, OnButtonGetAllSpots)
	ON_BN_CLICKED(IDC_BUTTON_GETANN, OnButtonGetAnnounces)
	ON_BN_CLICKED(IDC_BUTTON_GETLAST5, OnButtonGetLast5DX)
	ON_BN_CLICKED(IDC_BUTTON_GETLAST10, OnButtonGetLast10DX)
	ON_BN_CLICKED(IDC_BUTTON_SEND, OnButtonSend)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDXSpotterClientDlg message handlers

BOOL CDXSpotterClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_nResult = -1;
	m_cfMain.dwMask = CFM_CHARSET | CFM_FACE | CFM_SIZE | CFM_OFFSET | CFM_COLOR;
	m_cfMain.dwMask ^= CFM_ITALIC ^ CFM_BOLD ^ CFM_STRIKEOUT ^ CFM_UNDERLINE;
	m_cfMain.dwEffects = 0;
	m_cfMain.crTextColor = RGB(0,0,50);
	m_cfMain.yHeight = 180;
	m_cfMain.yOffset = 0;
	m_cfMain.bCharSet = ANSI_CHARSET;
	m_cfMain.bPitchAndFamily = FIXED_PITCH| FF_MODERN;
	strcpy(m_cfMain.szFaceName,"Courier New");
	m_cfMain.cbSize = sizeof(m_cfMain);
	m_reInfo.SetDefaultCharFormat(m_cfMain);

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	EnumSpotters();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDXSpotterClientDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDXSpotterClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDXSpotterClientDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CDXSpotterClientDlg::OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct) 
{
	m_nResult = pCopyDataStruct->dwData;

	int nLen = pCopyDataStruct->cbData;
	if(nLen>0)
	{
		CString strData;
		strData.Format("%s",pCopyDataStruct->lpData);
		strData.SetAt(nLen-1,'\0');

		long nLen = m_reInfo.GetTextLength();
		m_reInfo.SetSel(0,nLen);
		m_reInfo.SetSelectionCharFormat(m_cfMain);
		m_reInfo.ReplaceSel(strData,FALSE);
	}

	return CDialog::OnCopyData(pWnd, pCopyDataStruct);
}

void CDXSpotterClientDlg::EnumSpotters()
{
	HWND hWnd =::FindWindow(NULL,NULL); // dialog
	TCHAR szResult[MAX_PATH];
	
	m_lstSpotters.ResetContent();

	while(hWnd)
	{
		hWnd =::GetNextWindow(hWnd,GW_HWNDNEXT);
		
		if(hWnd)
		{
			memset(szResult,0,MAX_PATH);
			::GetWindowText(hWnd,szResult,MAX_PATH);
			
			if(strstr(szResult, "DXSpotter:")!=0 && strstr(szResult, "cluster")!=0)
			{
				CString strCall(szResult);
				strCall = strCall.Mid(strCall.Find(':')+1);
				strCall.TrimLeft();
				strCall = strCall.Left(strCall.Find(' '));
				strCall.TrimRight();

				m_lstSpotters.AddString(strCall);
			}
		}
	}

	if(m_lstSpotters.GetCount()>0) m_lstSpotters.SetCurSel(0);
}

void CDXSpotterClientDlg::SendMessageToSpotter(CString strMesage)
{
	int nSelected = m_lstSpotters.GetCurSel();

	if(nSelected!=-1)
	{
		CString strCall;
		m_lstSpotters.GetText(nSelected, strCall);

		strCall = "DXSpotter: "+strCall+" cluster";

		HWND hWndTarget = ::FindWindow("#32770",strCall);

		if(hWndTarget)
		{
			TCHAR szMessage[MAX_PATH];
			memset(szMessage,0,MAX_PATH);
			strcpy(szMessage, strMesage);

			COPYDATASTRUCT cd;
			cd.lpData = szMessage;
			cd.dwData = (DWORD)m_hWnd;
			cd.cbData= strlen(szMessage);
			::SendMessage(hWndTarget, WM_COPYDATA,0,(LPARAM) &cd);
		}
	}
	else 
		::MessageBox(m_hWnd,"DXSpotter is not running.", "DXSpotter Client", MB_OK|MB_ICONEXCLAMATION);
}

void CDXSpotterClientDlg::OnButtonRefresh() 
{
	EnumSpotters();	
}

void CDXSpotterClientDlg::OnButtonClose() 
{
	int nSelected = m_lstSpotters.GetCurSel();

	if(nSelected!=-1)
	{
		CString strCall;
		m_lstSpotters.GetText(nSelected, strCall);

		strCall = "DXSpotter: "+strCall+" cluster";

		SendMessageToSpotter("IsConnected");

		if(m_nResult == 0)
		{
			HWND hWndTarget = ::FindWindow("#32770",strCall);

			if(hWndTarget)
				::SendMessage(hWndTarget,WM_SYSCOMMAND, SC_CLOSE,0);
		}
		else 
			::MessageBox(m_hWnd,"DXSpotter is still connected. Please disconnect it from the cluster first.", "DXSpotter Client", MB_OK|MB_ICONEXCLAMATION);
	}
	else 
		::MessageBox(m_hWnd,"DXSpotter is not running.", "DXSpotter Client", MB_OK|MB_ICONEXCLAMATION);
}

void CDXSpotterClientDlg::OnButtonConnect() 
{
	int nSelected = m_lstSpotters.GetCurSel();

	if(nSelected!=-1)
	{
		CString strCall, strTarget;
		GetDlgItem(IDC_EDIT_CALL)->GetWindowText(strTarget);
		strTarget.TrimLeft();
		strTarget.TrimRight();

		if(strTarget.GetLength()>2)
		{
			m_lstSpotters.GetText(nSelected, strCall);

			strCall = "DXSpotter: "+strCall+" cluster";

			SendMessageToSpotter("Connect:"+strTarget);
		}
		else
		{
			::MessageBox(m_hWnd,"Please select valid cluster callsign.", "DXSpotter Client", MB_OK|MB_ICONEXCLAMATION);
			GetDlgItem(IDC_EDIT_CALL)->SetFocus();
		}
	}
	else 
		::MessageBox(m_hWnd,"DXSpotter is not running.", "DXSpotter Client", MB_OK|MB_ICONEXCLAMATION);
}

void CDXSpotterClientDlg::OnButtonDisconnect() 
{
	int nSelected = m_lstSpotters.GetCurSel();

	if(nSelected!=-1)
		SendMessageToSpotter("Disconnect");
	else 
		::MessageBox(m_hWnd,"DXSpotter is not running.", "DXSpotter Client", MB_OK|MB_ICONEXCLAMATION);
}

void CDXSpotterClientDlg::OnButtonGetAllText() 
{
	int nSelected = m_lstSpotters.GetCurSel();

	if(nSelected!=-1)
		SendMessageToSpotter("GetScreenText");
	else 
		::MessageBox(m_hWnd,"DXSpotter is not running.", "DXSpotter Client", MB_OK|MB_ICONEXCLAMATION);
}

void CDXSpotterClientDlg::OnButtonGetAllSpots() 
{
	int nSelected = m_lstSpotters.GetCurSel();

	if(nSelected!=-1)
		SendMessageToSpotter("GetSpots");
	else 
		::MessageBox(m_hWnd,"DXSpotter is not running.", "DXSpotter Client", MB_OK|MB_ICONEXCLAMATION);
}

void CDXSpotterClientDlg::OnButtonGetAnnounces() 
{
	int nSelected = m_lstSpotters.GetCurSel();

	if(nSelected!=-1)
		SendMessageToSpotter("GetAnnounces");
	else 
		::MessageBox(m_hWnd,"DXSpotter is not running.", "DXSpotter Client", MB_OK|MB_ICONEXCLAMATION);
}

void CDXSpotterClientDlg::OnButtonGetLast5DX() 
{
	int nSelected = m_lstSpotters.GetCurSel();

	if(nSelected!=-1)
		SendMessageToSpotter("GetLast5DX");
	else 
		::MessageBox(m_hWnd,"DXSpotter is not running.", "DXSpotter Client", MB_OK|MB_ICONEXCLAMATION);
}

void CDXSpotterClientDlg::OnButtonGetLast10DX() 
{
	int nSelected = m_lstSpotters.GetCurSel();

	if(nSelected!=-1)
		SendMessageToSpotter("GetLast10DX");
	else 
		::MessageBox(m_hWnd,"DXSpotter is not running.", "DXSpotter Client", MB_OK|MB_ICONEXCLAMATION);
}

void CDXSpotterClientDlg::OnButtonSend() 
{
	int nSelected = m_lstSpotters.GetCurSel();

	if(nSelected!=-1)
	{
		CString strMessage;
		GetDlgItem(IDC_EDIT_MESSAGE)->GetWindowText(strMessage);

		SendMessageToSpotter("SendMessage:"+strMessage);
	}	
	else
	{
		::MessageBox(m_hWnd,"DXSpotter is not running.", "DXSpotter Client", MB_OK|MB_ICONEXCLAMATION);
		GetDlgItem(IDC_EDIT_MESSAGE)->SetFocus();
	}
}
